local cdtable = {}
local PWB = Protwarbar:getPWB()

-- init the table to keep track of when a CD started
for i = 1, PWB_ICON_COUNT do
	cdtable[i] = {0, 0}
end

function Protwarbar:UpdateIcons()
	if PWB.db.profile.IconsEnabled == false then
		return nil
	end

	for i = 1, PWB_ICON_COUNT do
		if PWB.db.profile.icons[i].enabled then 
			Protwarbar:UpdateCooldown(PWB.db.profile.icons[i], PWB.iconFrames[i], PWB.IconCooldown[i], cdtable[i])
		end
	end
end

function Protwarbar:UpdateCooldown(icon, frame, cooldown, cdtable)
	local start, duration, enabled = GetSpellCooldown(icon.spellid);

	if cdtable[1] ~= start or cdtable[2] ~= duration then
		cdtable[1] = start
		cdtable[2] = duration

		if icon.hideOnCD then
			if duration > 1.5 then
				frame.texture:SetAlpha(0)
			else
				frame.texture:SetAlpha(1)
			end
		else
			CooldownFrame_SetTimer(cooldown, start, duration, 1)
		end
	end

end

function Protwarbar:UpdateRageRelatedIcons()
	if PWB.db.profile.IconsEnabled == false then
		return nil
	end

	for i = 1, PWB_ICON_COUNT do
		if PWB.db.profile.icons[i].enabled then
			if PWB.db.profile.icons[i].rage ~= nil then
				if UnitPower("player") < PWB.db.profile.icons[i].rage then
					PWB.iconFrames[i].texture:SetAlpha(PWB.db.profile.iconLowRageAlpha)
				else
					PWB.iconFrames[i].texture:SetAlpha(1)
				end
			end			
		end
	end

end


function Protwarbar:UpdateDebufIcons()
	for i = 1, PWB_DEBUF_COUNT do
		if PWB.db.profile.debufs[i].enabled then
			local n,_,_,_,_,d,e,_,_,_,id,_,_,val1,val2,val3 = UnitAura("target", PWB.db.profile.debufs[i].name, nil, "HARMFUL");
			
			if n then
				local duration = d or 0
				if d > 0 then
					CooldownFrame_SetTimer(PWB.debufCooldown[i], e-d, d, 1)
				end
			else
				CooldownFrame_SetTimer(PWB.debufCooldown[i], 1, 1, 1)
			end

		end
	end
end